--10/25/09 v0.9.0 Inital Release
--10/28/09 v0.9.5 Fixed Duration
--10/30/09 v0.9.6 Merged KidsWB and DCBeyond
--11/03/09 v0.9.7 Added scripts plugin version check
--Author - hottamale

--Standard code: Do a version check with the plugin
if (Version()<101) then
	VirtualFolder("Please update your Scripts Plugin","code:ExecuteFile('http://www.playonplugins.com/index.php/topic,1721.0.html');");
	return;
end;

--Global Array Variable
show_details = {};

function Get_WB_Channels()
	VirtualFolder("KidsWB","Get_WB_Shows|http://cdn.kidswb.com/kidswb/feeds/kidswb.xml");
	VirtualFolder("DC Beyond","Get_WB_Shows|http://cdn.kidswb.com/kidswb/feeds/dcbeyond.xml");
end;

function Get_WB_Shows(url)
	local s = GetURL(url);
	
	--Define variables
	local show = {};
		
	local showname = "";
	local title = "";
	local desc = "";
	local episode = "";
	local season = "";
	local thumb = "";
	local duration = 0;
	
	local a = 0;
	local b = 0;

	local embed = "";
	local embed_end = "";
	--VirtualFolder("Test","mydummyfunction");
		
	for i = 1, 1000 do
		--Find Show Title
		embed = "<media:title>";
		a = string.find(s, embed, b + 1);
			if not a then
				break;
			end;
		embed_end = "</media:title>";
		b = string.find(s, embed_end, a + string.len(embed));
		title=str_html_decode(string.sub(s, a + string.len(embed), b - 1));
		
		--Find Show Desc
		embed = "<media:description>";
		a = string.find(s, embed, b + string.len(embed_end));
			if not a then
				break;
			end;
		
		embed_end = "</media:description>";
		b = string.find(s, embed_end, a + string.len(embed));
		desc=str_html_decode(string.sub(s, a + string.len(embed), b - 1));


		--Find Episode (used to make video url)
		embed = '<av:episode number="';
		a = string.find(s, embed, b + string.len(embed_end));
			if not a then
				break;
			end;
		
		embed_end = '"';
		b = string.find(s, embed_end, a + string.len(embed));
		episode=tostring(str_html_decode(string.sub(s, a + string.len(embed), b - 1)));

		--Find Season (used to make video url)
		embed = '<av:show season="';
		a = string.find(s, embed, b + string.len(embed_end));
			if not a then
				break;
			end;
		
		embed_end = '"';
		b = string.find(s, embed_end, a + string.len(embed));
		season=tostring(str_html_decode(string.sub(s, a + string.len(embed), b - 1)));

		--Find Show Category (showname)
		--embed = '<av:show';
		--a = string.find(s, embed, c + 1);
		a = b + 2
		--	if not a then
		--		break;
		--	end;
		--b = string.find(s, '>', a + string.len(embed));
		embed_end = "</av:show>";
		b = string.find(s, embed_end, b + 1);
		showname=str_html_decode(string.sub(s, a, b - 1));
		
		--Find Duration
		embed = 'duration="';
		a = string.find(s, embed, b + string.len(embed_end));
			if not a then
				break;
			end;
		
		embed_end = '"';
		b = string.find(s, embed_end, a + string.len(embed));
		duration=str_html_decode(string.sub(s, a + string.len(embed), b - 1));

		--Find Thumbnail
		embed = '<media:thumbnail url="';
		a = string.find(s, embed, b + string.len(embed_end));
			if not a then
				break;
			end;
		
		embed_end = '"/>';
		b = string.find(s, embed_end, a + string.len(embed));
		thumb=str_html_decode(string.sub(s, a + string.len(embed), b - 1));
		
		--Store showname in 'show' array as the key field
		if show[showname] == nil then
			show[showname] = 1;
		  else
			show[showname] = show[showname] + 1;
		end;
		
		--Store all show details in global array 'show_details'
		table.insert(show_details, {["showname"] = showname, ["title"] = title, ["desc"] = desc, ["thumb"] = thumb, ["duration"] = duration});
	end;
	
	table.sort(show)
	for k,v in pairs(show) do
		--VirtualFolder(k.." ("..v.." Episodes)","Get_WB_Episodes|"..k);
		Get_WB_Episodes(k);
	end;

end;	
		
function Get_WB_Episodes(show_key)
		
		local swf="http://cdn.kidswb.com/kidswb/ds/wbkidsvideoplayer.swf";
	
		local stream="rtmp://wbads.fcod.llnwd.net/a2383/o33/kidswb/";
	
	
	for i,v in ipairs(show_details) do
		
		if show_details[i].showname == show_key then
			--http://pdl.warnerbros.com/wbtv/channels/thumbs/thenewscoobydoomysteries/01/thenewscoobydoomysteries_01_01_103x69.jpg
			local s = show_details[i].thumb;
			
			local a = 0;
			local b = 0;
			local vidpath = "";
			
			--Pull video path from thumb, reuse in video path
			embed = '/thumbs/';
			a = string.find(s, embed, b + 1);
				if not a then
					break;
				end;
			
			embed_end = '103x69.jpg';
			b = string.find(s, embed_end, a + string.len(embed));
			vidpath=string.sub(s, a + string.len(embed), b - 1);
			
			--Add path pulled from thumb into the video path
			--should look like this "mp4:channels/video/thenewscoobydoomysteries/01/thenewscoobydoomysteries_01_01_700kbps.mp4"
			local src="mp4:channels/video/"..vidpath.."700kbps.mp4";
			
			--this line formats the stream, location and flash file into something playon can understand
			local rtmpString = stream .. '|<rtmpMedia version="1.0" super="1"><mediaPath>' .. src .. '</mediaPath><connectParams><swfUrl>' .. swf .. '</swfUrl></connectParams></rtmpMedia>'; 
			
			local duration = tonumber(show_details[i].duration) * 1000;
			VideoResource(show_details[i].title, rtmpString, show_details[i].desc, show_details[i].thumb, duration);
			
		end;

	end;


end;

Get_WB_Channels();